/*! Built with http://stenciljs.com */
import { h } from './bscomponents.core.js';
import { p as _size, o as toLower, t as hasClass, s as addClass, r as removeClass, q as customEvent } from './chunk-89dac778.js';
import { a as _get } from './chunk-5259db55.js';
import { c as _has } from './chunk-93432030.js';
import { a as getTransitionDurationFromElement } from './chunk-8f426baa.js';
import { a as reflow } from './chunk-89796593.js';
import { a as getConfigBoolean } from './chunk-c1b19ebe.js';
import './chunk-64cf3b78.js';
var BsModal = /** @class */ (function () {
    function BsModal() {
        var _this = this;
        this.showEventName = 'show.bs.modal';
        this.shownEventName = 'shown.bs.modal';
        this.hideEventName = 'hide.bs.modal';
        this.hiddenEventName = 'hidden.bs.modal';
        this.showModal = false;
        this.handleDataDismissModalClick = function (event) {
            // console.log('handleDataDismissModalClick');
            // close the modal if the backdrop is clicked on
            if (!_this.modalEl.contains(event.target)) {
                _this.hide();
            }
            // Close the modal if a [data-dismiss="modal"] is clicked on
            if (_this.elementIsOrInADataDismissForThisModal(event.target)) {
                _this.hide();
            }
        };
        this.handleResizeEvent = function () {
            _this.adjustDialog();
        };
        this.hideModalBecauseEscapePressed = function (event) {
            var escapeKeycode = 27;
            if (event.which === escapeKeycode) {
                // event.preventDefault();
                _this.hide();
            }
        };
        this.handleFocusIn = function (event) {
            if (document !== event.target && !_this.modalEl.contains(event.target)) {
                _this.modalEl.focus();
            }
        };
        this.backdropClickDismiss = function (event) {
            // console.log('backdropClickDismiss');
            // debugger;
            if (event.target !== event.currentTarget) {
                return;
            }
            if (_get(_this.config, 'backdrop', '') === 'static') {
                _this.modalEl.focus();
            }
            else {
                _this.hide();
            }
        };
    }
    BsModal.prototype.componentWillLoad = function () {
        var _this = this;
        this.isShown = hasClass(this.modalEl, 'show');
        this.isTransitioning = false;
        if (this.showModal && !this.isShown) {
            this.getConfig();
            if (!hasClass(this.modalEl, 'fade')) {
                this.show();
                return;
            }
            removeClass(this.modalEl, 'fade'); // no animation when setting the initial state
            var transitionDuration = getTransitionDurationFromElement(this.modalEl);
            this.show();
            setTimeout(function () {
                addClass(_this.modalEl, 'fade');
            }, transitionDuration);
        }
        else if (!this.showModal && this.isShown) {
            this.getConfig();
            if (!hasClass(this.modalEl, 'fade')) {
                this.hide();
                return;
            }
            var transitionDuration = getTransitionDurationFromElement(this.modalEl);
            removeClass(this.modalEl, 'fade'); // no animation when setting the initial state
            this.hide();
            setTimeout(function () {
                addClass(_this.modalEl, 'fade');
            }, transitionDuration);
        }
    };
    BsModal.prototype.componentDidUnload = function () {
        this.unbindAllEventListenersUsed();
    };
    BsModal.prototype.unbindAllEventListenersUsed = function () {
        document.removeEventListener('focusin', this.handleFocusIn);
        this.modalEl.removeEventListener('click', this.backdropClickDismiss);
        document.removeEventListener('click', this.handleDataDismissModalClick);
        window.removeEventListener('resize', this.handleResizeEvent);
        document.removeEventListener('keydown', this.hideModalBecauseEscapePressed);
    };
    BsModal.prototype.getScrollbarWidth = function () {
        var scrollDiv = document.createElement('div');
        scrollDiv.className = 'modal-scrollbar-measure';
        document.body.appendChild(scrollDiv);
        var scrollbarWidth = scrollDiv.getBoundingClientRect().width - scrollDiv.clientWidth;
        document.body.removeChild(scrollDiv);
        return scrollbarWidth;
    };
    BsModal.prototype.checkScrollbar = function () {
        var rect = document.body.getBoundingClientRect();
        this.isBodyOverflowing = rect.left + rect.right < window.innerWidth;
        this.scrollbarWidth = this.getScrollbarWidth();
    };
    BsModal.prototype.setScrollbar = function () {
        if (this.isBodyOverflowing) {
            var fixedContent = Array.prototype.slice.call(document.querySelectorAll('.fixed-top, .fixed-bottom, .is-fixed, .sticky-top'));
            var stickyContent = Array.prototype.slice.call(document.querySelectorAll('.sticky-top'));
            // Adjust fixed content padding
            for (var j = 0, len = fixedContent.length; j < len; j += 1) {
                var actualPadding_1 = fixedContent[j].style.paddingRight;
                var calculatedPadding_1 = window.getComputedStyle(fixedContent[j])['padding-right'];
                fixedContent[j].dataset.paddingRight = actualPadding_1;
                fixedContent[j].style.paddingRight = parseFloat(calculatedPadding_1) + this.scrollbarWidth + "px";
            }
            // Adjust sticky content margin
            for (var j = 0, len = stickyContent.length; j < len; j += 1) {
                var actualMargin = stickyContent[j].style.marginRight;
                var calculatedMargin = window.getComputedStyle(stickyContent[j])['margin-right'];
                stickyContent[j].dataset.marginRight = actualMargin;
                stickyContent[j].style.marginRight = parseFloat(calculatedMargin) - this.scrollbarWidth + "px";
            }
            // Adjust body padding
            var actualPadding = document.body.style.paddingRight;
            var calculatedPadding = window.getComputedStyle(document.body)['padding-right'];
            document.body.dataset.paddingRight = actualPadding;
            document.body.style.paddingRight = parseFloat(calculatedPadding) + this.scrollbarWidth + "px";
        }
    };
    BsModal.resetScrollbar = function () {
        // Restore fixed content padding
        var fixedContent = Array.prototype.slice.call(document.querySelectorAll('.fixed-top, .fixed-bottom, .is-fixed, .sticky-top'));
        for (var j = 0, len = fixedContent.length; j < len; j += 1) {
            var padding_1 = fixedContent[j].dataset.paddingRight;
            delete fixedContent[j].dataset.paddingRight;
            fixedContent[j].style.paddingRight = padding_1 || '';
        }
        // Restore sticky content
        var stickyContent = Array.prototype.slice.call(document.querySelectorAll('.sticky-top'));
        for (var j = 0, len = stickyContent.length; j < len; j += 1) {
            var margin = stickyContent[j].dataset.marginRight;
            if (typeof margin !== 'undefined') {
                stickyContent[j].style.marginRight = margin;
                delete stickyContent[j].dataset.marginRight;
            }
        }
        // Restore body padding
        var padding = document.body.dataset.paddingRight;
        delete document.body.dataset.paddingRight;
        document.body.style.paddingRight = padding || '';
    };
    BsModal.prototype.adjustDialog = function () {
        var isModalOverflowing = this.modalEl.scrollHeight > document.documentElement.clientHeight;
        if (!this.isBodyOverflowing && isModalOverflowing) {
            this.modalEl.style.paddingLeft = this.scrollbarWidth + "px";
        }
        if (this.isBodyOverflowing && !isModalOverflowing) {
            this.modalEl.style.paddingRight = this.scrollbarWidth + "px";
        }
    };
    BsModal.prototype.hide = function () {
        var _this = this;
        // console.log('hide');
        if (this.isTransitioning || !this.isShown) {
            return;
        }
        var hideEvent = customEvent(this.modalEl, this.hideEventName);
        if (!this.isShown || hideEvent.defaultPrevented) {
            return;
        }
        this.isShown = false;
        var transition = hasClass(this.modalEl, 'fade');
        if (transition) {
            this.isTransitioning = true;
        }
        this.setEscapeEvent();
        this.setResizeEvent();
        document.removeEventListener('focusin', this.handleFocusIn);
        removeClass(this.modalEl, 'show');
        document.removeEventListener('click', this.handleDataDismissModalClick);
        if (transition) {
            var transitionDuration = getTransitionDurationFromElement(this.modalEl);
            setTimeout(function () {
                _this.hideModal();
            }, transitionDuration);
        }
        else {
            this.hideModal();
        }
    };
    BsModal.prototype.hideModal = function () {
        var _this = this;
        this.modalEl.style.display = 'none';
        this.modalEl.setAttribute('aria-hidden', 'true');
        this.isTransitioning = false;
        this.showBackdrop(function () {
            removeClass(document.body, 'modal-open');
            _this.resetAdjustments();
            BsModal.resetScrollbar();
            if (_this.relatedTarget) {
                _this.relatedTarget.focus();
                _this.relatedTarget = null;
            }
            var modalTransitionDuration = getTransitionDurationFromElement(_this.modalEl);
            // console.log('modalTransitionDuration: ', modalTransitionDuration);
            setTimeout(function () {
                window.requestAnimationFrame(function () {
                    window.requestAnimationFrame(function () {
                        customEvent(_this.modalEl, _this.hiddenEventName);
                    });
                });
            }, modalTransitionDuration);
            _this.unbindAllEventListenersUsed();
        });
    };
    BsModal.prototype.resetAdjustments = function () {
        this.modalEl.style.paddingLeft = '';
        this.modalEl.style.paddingRight = '';
    };
    BsModal.prototype.show = function (relatedTarget) {
        var _this = this;
        if (relatedTarget === void 0) { relatedTarget = null; }
        if (this.isTransitioning || this.isShown) {
            return;
        }
        if (hasClass(this.modalEl, 'fade')) {
            this.isTransitioning = true;
        }
        var showEvent = customEvent(this.modalEl, this.showEventName, {}, relatedTarget);
        if (this.isShown || showEvent.defaultPrevented) {
            return;
        }
        if (relatedTarget) {
            this.relatedTarget = relatedTarget;
        }
        this.isShown = true;
        this.checkScrollbar();
        this.setScrollbar();
        this.adjustDialog();
        addClass(document.body, 'modal-open');
        this.setEscapeEvent();
        this.setResizeEvent();
        this.setClicksThatCanCloseModalEvent();
        this.showBackdrop(function () { return _this.showElement(); });
    };
    BsModal.prototype.elementIsOrInADataDismissForThisModal = function (element) {
        var modalDataDismissArr = Array.prototype.slice.call(this.modalEl.querySelectorAll('[data-dismiss="modal"]'));
        for (var j = 0, len = modalDataDismissArr.length; j < len; j += 1) {
            if (modalDataDismissArr[j].contains(element)) {
                return true;
            }
        }
        return false;
    };
    BsModal.prototype.setClicksThatCanCloseModalEvent = function () {
        var _this = this;
        if (this.isShown) {
            setTimeout(function () {
                document.addEventListener('click', _this.handleDataDismissModalClick);
            }, 0);
        }
        else if (!this.isShown) {
            document.removeEventListener('click', this.handleDataDismissModalClick);
        }
    };
    BsModal.prototype.setResizeEvent = function () {
        if (this.isShown) {
            window.addEventListener('resize', this.handleResizeEvent);
        }
        else {
            window.removeEventListener('resize', this.handleResizeEvent);
        }
    };
    BsModal.prototype.setEscapeEvent = function () {
        if (this.isShown && this.config.keyboard) {
            document.addEventListener('keydown', this.hideModalBecauseEscapePressed);
        }
        else if (!this.isShown) {
            document.removeEventListener('keydown', this.hideModalBecauseEscapePressed);
        }
    };
    BsModal.prototype.getConfig = function (overrideConfig) {
        if (overrideConfig === void 0) { overrideConfig = {}; }
        this.config = {};
        var config = {};
        if (_has(overrideConfig, 'backdrop')) {
            var backdrop = toLower(_get(overrideConfig, 'backdrop', 'true'));
            config.backdrop = backdrop === 'static' ? 'static' : getConfigBoolean(backdrop);
        }
        else if (_has(this.modalEl.dataset, 'backdrop')) {
            var backdrop = toLower(this.modalEl.dataset.backdrop);
            config.backdrop = backdrop === 'static' ? 'static' : getConfigBoolean(backdrop);
        }
        else {
            config.backdrop = true;
        }
        if (_has(overrideConfig, 'focus')) {
            config.focus = getConfigBoolean(_get(overrideConfig, 'focus', true));
        }
        else if (_has(this.modalEl.dataset, 'focus')) {
            config.focus = getConfigBoolean(this.modalEl.dataset.focus);
        }
        else {
            config.focus = true;
        }
        if (_has(overrideConfig, 'keyboard')) {
            config.keyboard = getConfigBoolean(_get(overrideConfig, 'keyboard', true));
        }
        else if (_has(this.modalEl.dataset, 'keyboard')) {
            config.keyboard = getConfigBoolean(this.modalEl.dataset.keyboard);
        }
        else {
            config.keyboard = true;
        }
        if (_has(overrideConfig, 'show')) {
            config.show = getConfigBoolean(_get(overrideConfig, 'show', true));
        }
        else if (_has(this.modalEl.dataset, 'show')) {
            config.show = getConfigBoolean(this.modalEl.dataset.show);
        }
        else {
            config.show = true;
        }
        this.config = config;
    };
    BsModal.prototype.enforceFocus = function () {
        document.removeEventListener('focusin', this.handleFocusIn);
        document.addEventListener('focusin', this.handleFocusIn);
    };
    BsModal.prototype.showElement = function () {
        var _this = this;
        // console.log('showElement');
        var transition = hasClass(this.modalEl, 'fade');
        if (!this.modalEl.parentNode || this.modalEl.parentNode.nodeType !== Node.ELEMENT_NODE) {
            // Don't move modal's DOM position
            document.body.appendChild(this.modalEl);
        }
        this.modalEl.style.display = 'block';
        this.modalEl.removeAttribute('aria-hidden');
        this.modalEl.scrollTop = 0;
        if (transition) {
            reflow(this.modalEl);
        }
        addClass(this.modalEl, 'show');
        if (this.config.focus) {
            this.enforceFocus();
        }
        if (transition) {
            var transitionDuration = getTransitionDurationFromElement(this.modalEl);
            setTimeout(function () {
                if (_this.config.focus) {
                    _this.modalEl.focus();
                }
                _this.isTransitioning = false;
                window.requestAnimationFrame(function () {
                    window.requestAnimationFrame(function () {
                        setTimeout(function () {
                            customEvent(_this.modalEl, _this.shownEventName, {}, _this.relatedTarget);
                        }, 0);
                    });
                });
            }, transitionDuration);
        }
        else {
            window.requestAnimationFrame(function () {
                window.requestAnimationFrame(function () {
                    setTimeout(function () {
                        customEvent(_this.modalEl, _this.shownEventName, {}, _this.relatedTarget);
                    }, 0);
                });
            });
        }
    };
    BsModal.prototype.showBackdrop = function (callback) {
        var _this = this;
        if (callback === void 0) { callback = function () { }; }
        var animate = hasClass(this.modalEl, 'fade') ? 'fade' : '';
        if (this.isShown && this.config.backdrop) {
            this.backdrop = document.createElement('div');
            this.backdrop.className = 'modal-backdrop';
            if (animate) {
                this.backdrop.classList.add(animate);
            }
            document.body.appendChild(this.backdrop);
            this.modalEl.addEventListener('click', this.backdropClickDismiss);
            if (animate) {
                reflow(this.backdrop);
            }
            addClass(this.backdrop, 'show');
            if (!callback) {
                return;
            }
            if (!animate) {
                callback();
                return;
            }
            var backdropTransitionDuration = getTransitionDurationFromElement(this.backdrop);
            setTimeout(function () {
                // window.requestAnimationFrame(() => { // trick to ensure all page updates are completed before running code
                //   window.requestAnimationFrame(() => { // discussed here:  https://www.youtube.com/watch?v=aCMbSyngXB4&t=11m
                callback();
                //   });
                // });
            }, backdropTransitionDuration);
        }
        else if (!this.isShown && this.backdrop) {
            removeClass(this.backdrop, 'show');
            var hasBackdropRemoveAnimation = hasClass(this.modalEl, 'fade');
            if (hasBackdropRemoveAnimation) {
                var removeBackdropTransitionDuration = getTransitionDurationFromElement(this.backdrop);
                setTimeout(function () {
                    _this.removeBackdrop(callback);
                }, removeBackdropTransitionDuration);
            }
            else {
                this.removeBackdrop(callback);
            }
        }
        else {
            callback();
        }
    };
    BsModal.prototype.removeBackdrop = function (callback) {
        if (callback === void 0) { callback = function () { }; }
        // console.log('removeBackdrop');
        if (this.backdrop) {
            this.backdrop.parentNode.removeChild(this.backdrop);
            this.backdrop = null;
        }
        callback();
    };
    // @Method()
    // modalToggleButtonClicked(relatedTarget) {
    //   this.getConfig();
    //   if (this.isShown) {
    //     this.hide();
    //   } else {
    //     this.show(relatedTarget);
    //     // console.log('relatedTarget: ', relatedTarget);
    //   }
    // }
    BsModal.prototype.handleActiveWatch = function (newValue /* , oldValue */) {
        if (newValue) {
            this.getConfig();
            this.show();
            return;
        }
        this.hide();
    };
    BsModal.prototype.modal = function (modalOptions, relatedTarget) {
        if (modalOptions === void 0) { modalOptions = {}; }
        if (relatedTarget === void 0) { relatedTarget = null; }
        // console.log('modalOptions: ', modalOptions);
        if (_size(modalOptions) === 0) {
            return this.modalEl;
        }
        if (typeof modalOptions === 'object') {
            this.getConfig(modalOptions);
            if (this.config.show && !this.isShown) {
                this.show();
            }
            return true;
        }
        if (modalOptions === 'toggle') {
            this.getConfig();
            if (this.isShown) {
                this.hide();
            }
            else {
                this.show(relatedTarget);
            }
            return true;
        }
        if (modalOptions === 'show') {
            this.getConfig();
            this.show();
            return true;
        }
        if (modalOptions === 'hide') {
            // this.getConfig();
            this.hide();
            return true;
        }
        if (modalOptions === 'handleUpdate') {
            this.adjustDialog();
            return true;
        }
        if (typeof modalOptions === 'string') {
            throw new Error("No method named \"" + modalOptions + "\"");
        }
        return null;
    };
    BsModal.prototype.render = function () {
        return (h("slot", null));
    };
    Object.defineProperty(BsModal, "is", {
        get: function () { return "bs-modal"; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BsModal, "properties", {
        get: function () {
            return {
                "backdrop": {
                    "state": true
                },
                "config": {
                    "state": true
                },
                "getScrollbarWidth": {
                    "method": true
                },
                "hiddenEventName": {
                    "type": String,
                    "attr": "hidden-event-name"
                },
                "hideEventName": {
                    "type": String,
                    "attr": "hide-event-name"
                },
                "isBodyOverflowing": {
                    "state": true
                },
                "isShown": {
                    "state": true
                },
                "isTransitioning": {
                    "state": true
                },
                "modal": {
                    "method": true
                },
                "modalEl": {
                    "elementRef": true
                },
                "relatedTarget": {
                    "state": true
                },
                "scrollbarWidth": {
                    "state": true
                },
                "showEventName": {
                    "type": String,
                    "attr": "show-event-name"
                },
                "showModal": {
                    "type": Boolean,
                    "attr": "show-modal",
                    "mutable": true,
                    "watchCallbacks": ["handleActiveWatch"]
                },
                "shownEventName": {
                    "type": String,
                    "attr": "shown-event-name"
                }
            };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BsModal, "style", {
        get: function () { return "bs-modal {\n  display: block;\n}"; },
        enumerable: true,
        configurable: true
    });
    return BsModal;
}());
export { BsModal };
