/*! Built with http://stenciljs.com */
import { h } from './bscomponents.core.js';
import { e as toNumber_1, b as isIndex, d as isNaN$1, f as _isNumber } from './chunk-64cf3b78.js';
import { B as arrayMap, l as createCommonjsModule, C as root, c as baseGetTag, y as isLength, d as isObjectLike, v as isArray, D as baseKeys, j as isArrayLike, u as baseIndexOf, E as isString, w as getNative, p as _size, o as toLower, A as toString, F as _isObject, G as _isString, t as hasClass, r as removeClass, s as addClass, q as customEvent } from './chunk-89dac778.js';
import { b as baseUnary, c as nodeUtil, d as identity, e as split, a as getTransitionDurationFromElement } from './chunk-8f426baa.js';
import { d as isArguments, e as MapCache, c as _has } from './chunk-93432030.js';
import { a as Popper } from './chunk-f2a0d5d9.js';
import { a as _get } from './chunk-5259db55.js';
import { a as _trim } from './chunk-5260d582.js';
import { a as closest } from './chunk-5028a50e.js';
import { a as getConfigBoolean } from './chunk-c1b19ebe.js';
import { a as getUniqueId } from './chunk-ddbf79d9.js';
/** Used as references for various `Number` constants. */
var INFINITY = 1 / 0, MAX_INTEGER = 1.7976931348623157e+308;
/**
 * Converts `value` to a finite number.
 *
 * @static
 * @memberOf _
 * @since 4.12.0
 * @category Lang
 * @param {*} value The value to convert.
 * @returns {number} Returns the converted number.
 * @example
 *
 * _.toFinite(3.2);
 * // => 3.2
 *
 * _.toFinite(Number.MIN_VALUE);
 * // => 5e-324
 *
 * _.toFinite(Infinity);
 * // => 1.7976931348623157e+308
 *
 * _.toFinite('3.2');
 * // => 3.2
 */
function toFinite(value) {
    if (!value) {
        return value === 0 ? value : 0;
    }
    value = toNumber_1(value);
    if (value === INFINITY || value === -INFINITY) {
        var sign = (value < 0 ? -1 : 1);
        return sign * MAX_INTEGER;
    }
    return value === value ? value : 0;
}
var toFinite_1 = toFinite;
/**
 * Converts `value` to an integer.
 *
 * **Note:** This method is loosely based on
 * [`ToInteger`](http://www.ecma-international.org/ecma-262/7.0/#sec-tointeger).
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to convert.
 * @returns {number} Returns the converted integer.
 * @example
 *
 * _.toInteger(3.2);
 * // => 3
 *
 * _.toInteger(Number.MIN_VALUE);
 * // => 0
 *
 * _.toInteger(Infinity);
 * // => 1.7976931348623157e+308
 *
 * _.toInteger('3.2');
 * // => 3
 */
function toInteger(value) {
    var result = toFinite_1(value), remainder = result % 1;
    return result === result ? (remainder ? result - remainder : result) : 0;
}
var toInteger_1 = toInteger;
/**
 * The base implementation of `_.values` and `_.valuesIn` which creates an
 * array of `object` property values corresponding to the property names
 * of `props`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Array} props The property names to get values for.
 * @returns {Object} Returns the array of property values.
 */
function baseValues(object, props) {
    return arrayMap(props, function (key) {
        return object[key];
    });
}
var _baseValues = baseValues;
/**
 * The base implementation of `_.times` without support for iteratee shorthands
 * or max array length checks.
 *
 * @private
 * @param {number} n The number of times to invoke `iteratee`.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the array of results.
 */
function baseTimes(n, iteratee) {
    var index = -1, result = Array(n);
    while (++index < n) {
        result[index] = iteratee(index);
    }
    return result;
}
var _baseTimes = baseTimes;
/**
 * This method returns `false`.
 *
 * @static
 * @memberOf _
 * @since 4.13.0
 * @category Util
 * @returns {boolean} Returns `false`.
 * @example
 *
 * _.times(2, _.stubFalse);
 * // => [false, false]
 */
function stubFalse() {
    return false;
}
var stubFalse_1 = stubFalse;
var isBuffer_1 = createCommonjsModule(function (module, exports) {
    /** Detect free variable `exports`. */
    var freeExports = exports && !exports.nodeType && exports;
    /** Detect free variable `module`. */
    var freeModule = freeExports && 'object' == 'object' && module && !module.nodeType && module;
    /** Detect the popular CommonJS extension `module.exports`. */
    var moduleExports = freeModule && freeModule.exports === freeExports;
    /** Built-in value references. */
    var Buffer = moduleExports ? root.Buffer : undefined;
    /* Built-in method references for those with the same name as other `lodash` methods. */
    var nativeIsBuffer = Buffer ? Buffer.isBuffer : undefined;
    /**
     * Checks if `value` is a buffer.
     *
     * @static
     * @memberOf _
     * @since 4.3.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a buffer, else `false`.
     * @example
     *
     * _.isBuffer(new Buffer(2));
     * // => true
     *
     * _.isBuffer(new Uint8Array(2));
     * // => false
     */
    var isBuffer = nativeIsBuffer || stubFalse_1;
    module.exports = isBuffer;
});
/** `Object#toString` result references. */
var argsTag = '[object Arguments]', arrayTag = '[object Array]', boolTag = '[object Boolean]', dateTag = '[object Date]', errorTag = '[object Error]', funcTag = '[object Function]', mapTag = '[object Map]', numberTag = '[object Number]', objectTag = '[object Object]', regexpTag = '[object RegExp]', setTag = '[object Set]', stringTag = '[object String]', weakMapTag = '[object WeakMap]';
var arrayBufferTag = '[object ArrayBuffer]', dataViewTag = '[object DataView]', float32Tag = '[object Float32Array]', float64Tag = '[object Float64Array]', int8Tag = '[object Int8Array]', int16Tag = '[object Int16Array]', int32Tag = '[object Int32Array]', uint8Tag = '[object Uint8Array]', uint8ClampedTag = '[object Uint8ClampedArray]', uint16Tag = '[object Uint16Array]', uint32Tag = '[object Uint32Array]';
/** Used to identify `toStringTag` values of typed arrays. */
var typedArrayTags = {};
typedArrayTags[float32Tag] = typedArrayTags[float64Tag] =
    typedArrayTags[int8Tag] = typedArrayTags[int16Tag] =
        typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] =
            typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] =
                typedArrayTags[uint32Tag] = true;
typedArrayTags[argsTag] = typedArrayTags[arrayTag] =
    typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] =
        typedArrayTags[dataViewTag] = typedArrayTags[dateTag] =
            typedArrayTags[errorTag] = typedArrayTags[funcTag] =
                typedArrayTags[mapTag] = typedArrayTags[numberTag] =
                    typedArrayTags[objectTag] = typedArrayTags[regexpTag] =
                        typedArrayTags[setTag] = typedArrayTags[stringTag] =
                            typedArrayTags[weakMapTag] = false;
/**
 * The base implementation of `_.isTypedArray` without Node.js optimizations.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
 */
function baseIsTypedArray(value) {
    return isObjectLike(value) &&
        isLength(value.length) && !!typedArrayTags[baseGetTag(value)];
}
var _baseIsTypedArray = baseIsTypedArray;
/* Node.js helper references. */
var nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;
/**
 * Checks if `value` is classified as a typed array.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
 * @example
 *
 * _.isTypedArray(new Uint8Array);
 * // => true
 *
 * _.isTypedArray([]);
 * // => false
 */
var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : _baseIsTypedArray;
var isTypedArray_1 = isTypedArray;
/** Used for built-in method references. */
var objectProto = Object.prototype;
/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;
/**
 * Creates an array of the enumerable property names of the array-like `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @param {boolean} inherited Specify returning inherited property names.
 * @returns {Array} Returns the array of property names.
 */
function arrayLikeKeys(value, inherited) {
    var isArr = isArray(value), isArg = !isArr && isArguments(value), isBuff = !isArr && !isArg && isBuffer_1(value), isType = !isArr && !isArg && !isBuff && isTypedArray_1(value), skipIndexes = isArr || isArg || isBuff || isType, result = skipIndexes ? _baseTimes(value.length, String) : [], length = result.length;
    for (var key in value) {
        if ((inherited || hasOwnProperty.call(value, key)) &&
            !(skipIndexes && (
            // Safari 9 has enumerable `arguments.length` in strict mode.
            key == 'length' ||
                // Node.js 0.10 has enumerable non-index properties on buffers.
                (isBuff && (key == 'offset' || key == 'parent')) ||
                // PhantomJS 2 has enumerable non-index properties on typed arrays.
                (isType && (key == 'buffer' || key == 'byteLength' || key == 'byteOffset')) ||
                // Skip index properties.
                isIndex(key, length)))) {
            result.push(key);
        }
    }
    return result;
}
var _arrayLikeKeys = arrayLikeKeys;
/**
 * Creates an array of the own enumerable property names of `object`.
 *
 * **Note:** Non-object values are coerced to objects. See the
 * [ES spec](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
 * for more details.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Object
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.keys(new Foo);
 * // => ['a', 'b'] (iteration order is not guaranteed)
 *
 * _.keys('hi');
 * // => ['0', '1']
 */
function keys(object) {
    return isArrayLike(object) ? _arrayLikeKeys(object) : baseKeys(object);
}
var keys_1 = keys;
/**
 * Creates an array of the own enumerable string keyed property values of `object`.
 *
 * **Note:** Non-object values are coerced to objects.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Object
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property values.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.values(new Foo);
 * // => [1, 2] (iteration order is not guaranteed)
 *
 * _.values('hi');
 * // => ['h', 'i']
 */
function values(object) {
    return object == null ? [] : _baseValues(object, keys_1(object));
}
var values_1 = values;
/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeMax = Math.max;
/**
 * Checks if `value` is in `collection`. If `collection` is a string, it's
 * checked for a substring of `value`, otherwise
 * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * is used for equality comparisons. If `fromIndex` is negative, it's used as
 * the offset from the end of `collection`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Collection
 * @param {Array|Object|string} collection The collection to inspect.
 * @param {*} value The value to search for.
 * @param {number} [fromIndex=0] The index to search from.
 * @param- {Object} [guard] Enables use as an iteratee for methods like `_.reduce`.
 * @returns {boolean} Returns `true` if `value` is found, else `false`.
 * @example
 *
 * _.includes([1, 2, 3], 1);
 * // => true
 *
 * _.includes([1, 2, 3], 1, 2);
 * // => false
 *
 * _.includes({ 'a': 1, 'b': 2 }, 1);
 * // => true
 *
 * _.includes('abcd', 'bc');
 * // => true
 */
function includes(collection, value, fromIndex, guard) {
    collection = isArrayLike(collection) ? collection : values_1(collection);
    fromIndex = (fromIndex && !guard) ? toInteger_1(fromIndex) : 0;
    var length = collection.length;
    if (fromIndex < 0) {
        fromIndex = nativeMax(length + fromIndex, 0);
    }
    return isString(collection)
        ? (fromIndex <= length && collection.indexOf(value, fromIndex) > -1)
        : (!!length && baseIndexOf(collection, value, fromIndex) > -1);
}
var includes_1 = includes;
/** Used to stand-in for `undefined` hash values. */
var HASH_UNDEFINED = '__lodash_hash_undefined__';
/**
 * Adds `value` to the array cache.
 *
 * @private
 * @name add
 * @memberOf SetCache
 * @alias push
 * @param {*} value The value to cache.
 * @returns {Object} Returns the cache instance.
 */
function setCacheAdd(value) {
    this.__data__.set(value, HASH_UNDEFINED);
    return this;
}
var _setCacheAdd = setCacheAdd;
/**
 * Checks if `value` is in the array cache.
 *
 * @private
 * @name has
 * @memberOf SetCache
 * @param {*} value The value to search for.
 * @returns {number} Returns `true` if `value` is found, else `false`.
 */
function setCacheHas(value) {
    return this.__data__.has(value);
}
var _setCacheHas = setCacheHas;
/**
 *
 * Creates an array cache object to store unique values.
 *
 * @private
 * @constructor
 * @param {Array} [values] The values to cache.
 */
function SetCache(values) {
    var index = -1, length = values == null ? 0 : values.length;
    this.__data__ = new MapCache;
    while (++index < length) {
        this.add(values[index]);
    }
}
// Add methods to `SetCache`.
SetCache.prototype.add = SetCache.prototype.push = _setCacheAdd;
SetCache.prototype.has = _setCacheHas;
var _SetCache = SetCache;
/**
 * A specialized version of `_.includes` for arrays without support for
 * specifying an index to search from.
 *
 * @private
 * @param {Array} [array] The array to inspect.
 * @param {*} target The value to search for.
 * @returns {boolean} Returns `true` if `target` is found, else `false`.
 */
function arrayIncludes(array, value) {
    var length = array == null ? 0 : array.length;
    return !!length && baseIndexOf(array, value, 0) > -1;
}
var _arrayIncludes = arrayIncludes;
/**
 * This function is like `arrayIncludes` except that it accepts a comparator.
 *
 * @private
 * @param {Array} [array] The array to inspect.
 * @param {*} target The value to search for.
 * @param {Function} comparator The comparator invoked per element.
 * @returns {boolean} Returns `true` if `target` is found, else `false`.
 */
function arrayIncludesWith(array, value, comparator) {
    var index = -1, length = array == null ? 0 : array.length;
    while (++index < length) {
        if (comparator(value, array[index])) {
            return true;
        }
    }
    return false;
}
var _arrayIncludesWith = arrayIncludesWith;
/**
 * Checks if a `cache` value for `key` exists.
 *
 * @private
 * @param {Object} cache The cache to query.
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function cacheHas(cache, key) {
    return cache.has(key);
}
var _cacheHas = cacheHas;
/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeMin = Math.min;
/**
 * The base implementation of methods like `_.intersection`, without support
 * for iteratee shorthands, that accepts an array of arrays to inspect.
 *
 * @private
 * @param {Array} arrays The arrays to inspect.
 * @param {Function} [iteratee] The iteratee invoked per element.
 * @param {Function} [comparator] The comparator invoked per element.
 * @returns {Array} Returns the new array of shared values.
 */
function baseIntersection(arrays, iteratee, comparator) {
    var includes = comparator ? _arrayIncludesWith : _arrayIncludes, length = arrays[0].length, othLength = arrays.length, othIndex = othLength, caches = Array(othLength), maxLength = Infinity, result = [];
    while (othIndex--) {
        var array = arrays[othIndex];
        if (othIndex && iteratee) {
            array = arrayMap(array, baseUnary(iteratee));
        }
        maxLength = nativeMin(array.length, maxLength);
        caches[othIndex] = !comparator && (iteratee || (length >= 120 && array.length >= 120))
            ? new _SetCache(othIndex && array)
            : undefined;
    }
    array = arrays[0];
    var index = -1, seen = caches[0];
    outer: while (++index < length && result.length < maxLength) {
        var value = array[index], computed = iteratee ? iteratee(value) : value;
        value = (comparator || value !== 0) ? value : 0;
        if (!(seen
            ? _cacheHas(seen, computed)
            : includes(result, computed, comparator))) {
            othIndex = othLength;
            while (--othIndex) {
                var cache = caches[othIndex];
                if (!(cache
                    ? _cacheHas(cache, computed)
                    : includes(arrays[othIndex], computed, comparator))) {
                    continue outer;
                }
            }
            if (seen) {
                seen.push(computed);
            }
            result.push(value);
        }
    }
    return result;
}
var _baseIntersection = baseIntersection;
/**
 * A faster alternative to `Function#apply`, this function invokes `func`
 * with the `this` binding of `thisArg` and the arguments of `args`.
 *
 * @private
 * @param {Function} func The function to invoke.
 * @param {*} thisArg The `this` binding of `func`.
 * @param {Array} args The arguments to invoke `func` with.
 * @returns {*} Returns the result of `func`.
 */
function apply(func, thisArg, args) {
    switch (args.length) {
        case 0: return func.call(thisArg);
        case 1: return func.call(thisArg, args[0]);
        case 2: return func.call(thisArg, args[0], args[1]);
        case 3: return func.call(thisArg, args[0], args[1], args[2]);
    }
    return func.apply(thisArg, args);
}
var _apply = apply;
/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeMax$1 = Math.max;
/**
 * A specialized version of `baseRest` which transforms the rest array.
 *
 * @private
 * @param {Function} func The function to apply a rest parameter to.
 * @param {number} [start=func.length-1] The start position of the rest parameter.
 * @param {Function} transform The rest array transform.
 * @returns {Function} Returns the new function.
 */
function overRest(func, start, transform) {
    start = nativeMax$1(start === undefined ? (func.length - 1) : start, 0);
    return function () {
        var args = arguments, index = -1, length = nativeMax$1(args.length - start, 0), array = Array(length);
        while (++index < length) {
            array[index] = args[start + index];
        }
        index = -1;
        var otherArgs = Array(start + 1);
        while (++index < start) {
            otherArgs[index] = args[index];
        }
        otherArgs[start] = transform(array);
        return _apply(func, this, otherArgs);
    };
}
var _overRest = overRest;
/**
 * Creates a function that returns `value`.
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Util
 * @param {*} value The value to return from the new function.
 * @returns {Function} Returns the new constant function.
 * @example
 *
 * var objects = _.times(2, _.constant({ 'a': 1 }));
 *
 * console.log(objects);
 * // => [{ 'a': 1 }, { 'a': 1 }]
 *
 * console.log(objects[0] === objects[1]);
 * // => true
 */
function constant(value) {
    return function () {
        return value;
    };
}
var constant_1 = constant;
var defineProperty = (function () {
    try {
        var func = getNative(Object, 'defineProperty');
        func({}, '', {});
        return func;
    }
    catch (e) { }
}());
var _defineProperty = defineProperty;
/**
 * The base implementation of `setToString` without support for hot loop shorting.
 *
 * @private
 * @param {Function} func The function to modify.
 * @param {Function} string The `toString` result.
 * @returns {Function} Returns `func`.
 */
var baseSetToString = !_defineProperty ? identity : function (func, string) {
    return _defineProperty(func, 'toString', {
        'configurable': true,
        'enumerable': false,
        'value': constant_1(string),
        'writable': true
    });
};
var _baseSetToString = baseSetToString;
/** Used to detect hot functions by number of calls within a span of milliseconds. */
var HOT_COUNT = 800, HOT_SPAN = 16;
/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeNow = Date.now;
/**
 * Creates a function that'll short out and invoke `identity` instead
 * of `func` when it's called `HOT_COUNT` or more times in `HOT_SPAN`
 * milliseconds.
 *
 * @private
 * @param {Function} func The function to restrict.
 * @returns {Function} Returns the new shortable function.
 */
function shortOut(func) {
    var count = 0, lastCalled = 0;
    return function () {
        var stamp = nativeNow(), remaining = HOT_SPAN - (stamp - lastCalled);
        lastCalled = stamp;
        if (remaining > 0) {
            if (++count >= HOT_COUNT) {
                return arguments[0];
            }
        }
        else {
            count = 0;
        }
        return func.apply(undefined, arguments);
    };
}
var _shortOut = shortOut;
/**
 * Sets the `toString` method of `func` to return `string`.
 *
 * @private
 * @param {Function} func The function to modify.
 * @param {Function} string The `toString` result.
 * @returns {Function} Returns `func`.
 */
var setToString = _shortOut(_baseSetToString);
var _setToString = setToString;
/**
 * The base implementation of `_.rest` which doesn't validate or coerce arguments.
 *
 * @private
 * @param {Function} func The function to apply a rest parameter to.
 * @param {number} [start=func.length-1] The start position of the rest parameter.
 * @returns {Function} Returns the new function.
 */
function baseRest(func, start) {
    return _setToString(_overRest(func, start, identity), func + '');
}
var _baseRest = baseRest;
/**
 * This method is like `_.isArrayLike` except that it also checks if `value`
 * is an object.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an array-like object,
 *  else `false`.
 * @example
 *
 * _.isArrayLikeObject([1, 2, 3]);
 * // => true
 *
 * _.isArrayLikeObject(document.body.children);
 * // => true
 *
 * _.isArrayLikeObject('abc');
 * // => false
 *
 * _.isArrayLikeObject(_.noop);
 * // => false
 */
function isArrayLikeObject(value) {
    return isObjectLike(value) && isArrayLike(value);
}
var isArrayLikeObject_1 = isArrayLikeObject;
/**
 * Casts `value` to an empty array if it's not an array like object.
 *
 * @private
 * @param {*} value The value to inspect.
 * @returns {Array|Object} Returns the cast array-like object.
 */
function castArrayLikeObject(value) {
    return isArrayLikeObject_1(value) ? value : [];
}
var _castArrayLikeObject = castArrayLikeObject;
/**
 * Creates an array of unique values that are included in all given arrays
 * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * for equality comparisons. The order and references of result values are
 * determined by the first array.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Array
 * @param {...Array} [arrays] The arrays to inspect.
 * @returns {Array} Returns the new array of intersecting values.
 * @example
 *
 * _.intersection([2, 1], [2, 3]);
 * // => [2]
 */
var intersection = _baseRest(function (arrays) {
    var mapped = arrayMap(arrays, _castArrayLikeObject);
    return (mapped.length && mapped[0] === arrays[0])
        ? _baseIntersection(mapped)
        : [];
});
var intersection_1 = intersection;
/**
 * Checks if `value` is an integer.
 *
 * **Note:** This method is based on
 * [`Number.isInteger`](https://mdn.io/Number/isInteger).
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an integer, else `false`.
 * @example
 *
 * _.isInteger(3);
 * // => true
 *
 * _.isInteger(Number.MIN_VALUE);
 * // => false
 *
 * _.isInteger(Infinity);
 * // => false
 *
 * _.isInteger('3');
 * // => false
 */
function isInteger(value) {
    return typeof value == 'number' && value == toInteger_1(value);
}
var isInteger_1 = isInteger;
function parseJson(str) {
    try {
        return JSON.parse(str);
    }
    catch (e) {
        return false;
    }
}
var BsTooltip = /** @class */ (function () {
    function BsTooltip() {
        var _this = this;
        this.showEventName = 'show.bs.tooltip';
        this.shownEventName = 'shown.bs.tooltip';
        this.hideEventName = 'hide.bs.tooltip';
        this.hiddenEventName = 'hidden.bs.tooltip';
        this.insertedEventName = 'inserted.bs.tooltip';
        this.enableEventName = 'enable.bs.tooltip';
        this.enabledEventName = 'enabled.bs.tooltip';
        this.disableEventName = 'disable.bs.tooltip';
        this.disabledEventName = 'disabled.bs.tooltip';
        this.showTooltip = false;
        this.showPopover = false;
        this.disabled = false;
        this.tabindex = '0';
        this.bsContent = '';
        this.bsTitle = '';
        this.config = {};
        this.defaults = {
            animation: true,
            template: '<div class="tooltip" role="tooltip"><div class="arrow"></div><div class="tooltip-inner"></div></div>',
            popoverTemplate: '<div class="popover" role="tooltip"><div class="arrow"></div><h3 class="popover-header"></h3><div class="popover-body"></div></div>',
            trigger: 'hover focus',
            popoverTrigger: 'click',
            title: '',
            delay: 0,
            html: false,
            selector: false,
            placement: 'top',
            popoverPlacement: 'right',
            offset: 0,
            container: false,
            fallbackPlacement: 'flip',
            boundary: 'scrollParent',
            disposeTimeToWait: 0,
            toggle: 'tooltip',
            content: '',
        };
        this.handlePopperOnCreate = function (data) {
            if (data.originalPlacement !== data.placement) {
                _this.handlePopperPlacementChange(data);
            }
        };
        this.handlePopperOnUpdate = function (data) {
            _this.handlePopperPlacementChange(data);
        };
        this.handleClickTrigger = function (event) {
            _this.toggle(event);
        };
        this.handleMouseEnter = function (event) {
            _this.enter(event);
        };
        this.handleFocusIn = function (event) {
            _this.enter(event);
        };
        this.handleMouseLeave = function (event) {
            _this.leave(event);
        };
        this.handleFocusOut = function (event) {
            _this.leave(event);
        };
        this.handleModalHide = function (event) {
            console.log('handleModalHide');
            _this.activeTrigger = {};
            _this.leave(event);
        };
    }
    BsTooltip.prototype.componentWillLoad = function () {
        if (this.tabindex === '-1') {
            this.tabindex = -1;
        }
        if (this.disabled) {
            this.disableTooltip();
            return;
        }
        if (!this.isEnabled) {
            this.enableTooltip();
        }
        if (this.tooltipEl.dataset.toggle === 'tooltip' && this.showTooltip === true) {
            this.setInitialOpenOrCloseState(this.showTooltip);
        }
        else if (this.tooltipEl.dataset.toggle === 'popover' && this.showPopover === true) {
            this.setInitialOpenOrCloseState(this.showPopover);
        }
    };
    BsTooltip.prototype.setInitialOpenOrCloseState = function (present) {
        var _this = this;
        if (this.isEnabled && present) {
            var hasAnimation_1 = this.config.animation;
            if (hasAnimation_1) {
                this.setConfig({ animation: false });
            }
            this.tooltipEl.addEventListener(this.shownEventName, function () {
                if (includes_1(_this.config.trigger, 'click')) {
                    _this.activeTrigger.click = true;
                }
                else if (includes_1(_this.config.trigger, 'hover') && !includes_1(_this.config.trigger, 'manual')) {
                    _this.activeTrigger.hover = true;
                    _this.hoverState = 'show';
                }
                else if (includes_1(_this.config.trigger, 'focus') && !includes_1(_this.config.trigger, 'manual')) {
                    _this.activeTrigger.focus = true;
                }
                if (hasAnimation_1) {
                    _this.setConfig();
                    var tipEl = _this.tip || _this.makeTip();
                    addClass(tipEl, 'fade');
                }
            }, { once: true });
            this.enter();
        }
    };
    BsTooltip.prototype.componentDidUnload = function () {
        this.disableTooltip();
        this.config = {};
    };
    BsTooltip.getAttachment = function (placement) {
        var AttachmentMap = {
            auto: 'auto',
            top: 'top',
            right: 'right',
            bottom: 'bottom',
            left: 'left',
        };
        return AttachmentMap[toLower(placement)];
    };
    BsTooltip.prototype.enableTooltip = function () {
        var _this = this;
        if (this.disabled === true) {
            return;
        }
        var enableEvent = customEvent(this.tooltipEl, this.enableEventName);
        if (enableEvent.defaultPrevented) {
            return;
        }
        this.isEnabled = true;
        this.activeTrigger = {};
        this.hoverState = '';
        this.tooltipId = getUniqueId('tooltip');
        this.tooltipEl.dataset.bsId = this.tooltipId;
        this.tip = null;
        if (_size(this.config) === 0) {
            this.setConfig();
        }
        this.setListeners();
        window.requestAnimationFrame(function () {
            window.requestAnimationFrame(function () {
                setTimeout(function () {
                    customEvent(_this.tooltipEl, _this.enabledEventName);
                }, 0);
            });
        });
    };
    BsTooltip.prototype.disableTooltip = function () {
        var _this = this;
        // if (this.disabled === false) {
        //   return;
        // }
        var disableEvent = customEvent(this.tooltipEl, this.disableEventName);
        if (disableEvent.defaultPrevented) {
            return;
        }
        this.isEnabled = false;
        clearTimeout(this.timeout);
        this.bsRemoveEventListener('click', this.handleClickTrigger);
        this.bsRemoveEventListener('mouseenter', this.handleMouseEnter);
        this.bsRemoveEventListener('mouseleave', this.handleMouseLeave);
        this.bsRemoveEventListener('focusin', this.handleFocusIn);
        this.bsRemoveEventListener('focusout', this.handleFocusOut);
        var originalTitle = this.tooltipEl.dataset.originalTitle;
        if (_size(originalTitle) > 0) {
            this.tooltipEl.title = originalTitle;
        }
        var closestModal = closest(this.tooltipEl, '.modal');
        if (closestModal) {
            var modalHideEventName = closestModal.hideEventName;
            if (modalHideEventName) {
                closestModal.removeEventListener(closestModal.hideEventName, this.handleModalHide);
            }
        }
        this.activeTrigger = {};
        this.hoverState = '';
        clearTimeout(this.disposeTimeout);
        this.removeTooltipFromDom();
        if (this.popperHandle && this.popperHandle.destroy) {
            this.popperHandle.destroy();
            this.popperHandle = null;
        }
        window.requestAnimationFrame(function () {
            window.requestAnimationFrame(function () {
                setTimeout(function () {
                    customEvent(_this.tooltipEl, _this.disabledEventName);
                }, 0);
            });
        });
    };
    BsTooltip.prototype.makeTip = function () {
        var tipThatIsAlreadyInTheDom = document.getElementById(this.tooltipId);
        if (tipThatIsAlreadyInTheDom) {
            return tipThatIsAlreadyInTheDom;
        }
        var container = !this.config.container ? document.body : document.querySelector(this.config.container);
        var template = document.createElement('div');
        template.innerHTML = _trim(this.config.template);
        var innerTemplateTooltip = template.firstChild;
        var newTip = container.appendChild(innerTemplateTooltip);
        newTip.setAttribute('id', this.tooltipId);
        return newTip;
    };
    BsTooltip.prototype.getTipElement = function () {
        clearTimeout(this.disposeTimeout);
        this.tip = this.tip || this.makeTip();
        return this.tip;
    };
    BsTooltip.prototype.toggle = function (event) {
        if (event === void 0) { event = null; }
        if (!this.isEnabled) {
            return;
        }
        if (event) {
            this.activeTrigger.click = !this.activeTrigger.click;
            if (this.isWithActiveTrigger()) {
                this.enter();
            }
            else {
                this.leave();
            }
        }
        else if (this.tipHasClass('show')) {
            this.leave();
        }
        else {
            this.enter();
        }
    };
    BsTooltip.prototype.isWithActiveTrigger = function () {
        var _this = this;
        var activeTriggerKeys = Object.keys(this.activeTrigger);
        return activeTriggerKeys.some(function (triggerKey) { return _this.activeTrigger[triggerKey]; });
    };
    BsTooltip.prototype.tipHasClass = function (className) {
        if (!this.tip) {
            return false;
        }
        return hasClass(this.tip, className);
    };
    BsTooltip.prototype.enter = function (event) {
        var _this = this;
        if (event === void 0) { event = null; }
        if (event) {
            if (event.type === 'focusin') {
                this.activeTrigger.focus = true;
            }
            else {
                this.activeTrigger.hover = true;
            }
        }
        if (this.tipHasClass('show') || this.hoverState === 'show') {
            this.hoverState = 'show';
            return;
        }
        clearTimeout(this.timeout);
        this.hoverState = 'show';
        if (!this.config.delay || !this.config.delay.show) {
            this.show();
            return;
        }
        this.timeout = setTimeout(function () {
            if (_this.hoverState === 'show') {
                _this.show();
            }
        }, this.config.delay.show);
    };
    BsTooltip.prototype.leave = function (event) {
        var _this = this;
        if (event === void 0) { event = null; }
        if (event) {
            if (event.type === 'focusout') {
                this.activeTrigger.focus = false;
            }
            else {
                this.activeTrigger.hover = false;
            }
        }
        if (this.isWithActiveTrigger()) {
            return;
        }
        clearTimeout(this.timeout);
        this.hoverState = 'out';
        if (!this.config.delay || !this.config.delay.hide) {
            this.hide();
            return;
        }
        this.timeout = setTimeout(function () {
            if (_this.hoverState === 'out') {
                _this.hide();
            }
        }, this.config.delay.hide);
    };
    BsTooltip.prototype.okToShow = function () {
        if (!this.isEnabled) {
            return false;
        }
        var title = this.getTitle();
        if (title && title.length > 0) {
            return true;
        }
        if (title && title instanceof Element) {
            return true;
        }
        if (this.config.toggle === 'popover') {
            return true;
        }
        return false;
    };
    BsTooltip.prototype.show = function () {
        var _this = this;
        if (this.tooltipEl.style.display === 'none') {
            throw new Error('Please use show on visible elements');
        }
        if (this.okToShow()) {
            var showEvent = customEvent(this.tooltipEl, this.showEventName);
            this.tooltipEl.setAttribute('aria-describedby', this.tooltipId);
            var isInTheDom = this.tooltipEl.ownerDocument.documentElement.contains(this.tooltipEl);
            if (showEvent.defaultPrevented || !isInTheDom) {
                return;
            }
            var tip = this.getTipElement();
            this.setContent();
            if (this.config.animation) {
                addClass(tip, 'fade');
            }
            var placement = typeof this.config.placement === 'function' ? this.config.placement.call(this, tip, this.tooltipEl) : this.config.placement;
            var attachment = BsTooltip.getAttachment(placement);
            this.addAttachmentClass(attachment);
            // the point of inserted event is to know when the tip is in the dom but before it has been placed using popper
            customEvent(this.tooltipEl, this.insertedEventName);
            this.popperHandle = new Popper(this.tooltipEl, tip, {
                placement: attachment,
                modifiers: {
                    offset: {
                        offset: this.config.offset,
                    },
                    flip: {
                        behavior: this.config.fallbackPlacement,
                    },
                    arrow: {
                        element: '.arrow',
                    },
                    preventOverflow: {
                        boundariesElement: this.config.boundary,
                    },
                },
                onCreate: this.handlePopperOnCreate,
                onUpdate: this.handlePopperOnUpdate,
            });
            addClass(tip, 'show');
            // If this is a touch-enabled device we add extra
            // empty mouseover listeners to the body's immediate children;
            // only needed because of broken event delegation on iOS
            // https://www.quirksmode.org/blog/archives/2014/02/mouse_event_bub.html
            // if ('ontouchstart' in document.documentElement) {
            //   $$$1(document.body).children().on('mouseover', null, $$$1.noop);
            // }
            if (hasClass(tip, 'fade')) {
                var transitionDuration = getTransitionDurationFromElement(tip);
                setTimeout(function () {
                    _this.showComplete();
                }, transitionDuration);
            }
            else {
                this.showComplete();
            }
        }
    };
    BsTooltip.prototype.handlePopperPlacementChange = function (popperData) {
        var popperInstance = popperData.instance;
        this.tip = popperInstance.popper;
        this.cleanTipClass();
        this.addAttachmentClass(BsTooltip.getAttachment(popperData.placement));
    };
    BsTooltip.prototype.showComplete = function () {
        var _this = this;
        if (this.config.animation) {
            this.fixTransition();
        }
        var prevHoverState = this.hoverState;
        this.hoverState = null;
        window.requestAnimationFrame(function () {
            window.requestAnimationFrame(function () {
                setTimeout(function () {
                    customEvent(_this.tooltipEl, _this.shownEventName);
                }, 0);
            });
        });
        if (prevHoverState === 'out') {
            this.leave();
        }
    };
    BsTooltip.prototype.hide = function (callback) {
        var _this = this;
        if (callback === void 0) { callback = function () { }; }
        var tip = this.getTipElement();
        var hideEvent = customEvent(this.tooltipEl, this.hideEventName);
        if (hideEvent.defaultPrevented) {
            return;
        }
        removeClass(tip, 'show');
        // If this is a touch-enabled device we remove the extra
        // empty mouseover listeners we added for iOS support
        // if ('ontouchstart' in document.documentElement) {
        //   $$$1(document.body).children().off('mouseover', null, $$$1.noop);
        // }
        this.activeTrigger.click = false;
        this.activeTrigger.focus = false;
        this.activeTrigger.hover = false;
        this.tooltipEl.removeAttribute('aria-describedby');
        if (hasClass(tip, 'fade')) {
            var transitionDuration = getTransitionDurationFromElement(tip);
            setTimeout(function () {
                _this.hideComplete(callback);
            }, transitionDuration);
        }
        else {
            this.hideComplete();
        }
        this.hoverState = '';
    };
    BsTooltip.prototype.hideComplete = function (callback) {
        var _this = this;
        if (callback === void 0) { callback = function () { }; }
        this.cleanTipClass();
        if (this.popperHandle && this.popperHandle.destroy) {
            this.popperHandle.destroy();
        }
        this.disposeTimeout = setTimeout(function () {
            _this.removeTooltipFromDom();
        }, this.config.disposeTimeToWait);
        window.requestAnimationFrame(function () {
            window.requestAnimationFrame(function () {
                setTimeout(function () {
                    customEvent(_this.tooltipEl, _this.hiddenEventName);
                }, 0);
            });
        });
        callback();
    };
    BsTooltip.prototype.removeTooltipFromDom = function () {
        if (this.tip && this.hoverState !== 'show' && this.tip.parentNode) {
            this.tip.parentNode.removeChild(this.tip);
            this.tip = null;
        }
    };
    BsTooltip.prototype.fixTransition = function () {
        var tip = this.getTipElement();
        var initConfigAnimation = this.config.animation;
        if (tip.getAttribute('x-placement') !== null) {
            return;
        }
        removeClass(tip, 'fade');
        this.config.animation = false;
        this.hide();
        this.show();
        this.config.animation = initConfigAnimation;
    };
    BsTooltip.prototype.cleanTipClass = function () {
        var tip = this.getTipElement();
        var bsTooltipPositionClasses = [
            'bs-tooltip-auto',
            'bs-tooltip-top',
            'bs-tooltip-right',
            'bs-tooltip-bottom',
            'bs-tooltip-left',
            'bs-popover-auto',
            'bs-popover-top',
            'bs-popover-right',
            'bs-popover-bottom',
            'bs-popover-left',
        ];
        var classesToRemove = intersection_1(bsTooltipPositionClasses, tip.classList);
        for (var j = 0, len = classesToRemove.length; j < len; j += 1) {
            removeClass(tip, classesToRemove[j]);
        }
    };
    BsTooltip.prototype.addAttachmentClass = function (attachment) {
        addClass(this.getTipElement(), "bs-" + this.config.toggle + "-" + attachment);
    };
    BsTooltip.prototype.setContent = function () {
        var tip = this.getTipElement();
        var tooltipTitleEl;
        var tooltipContentEl;
        if (this.config.toggle === 'tooltip') {
            tooltipTitleEl = tip.querySelector('.tooltip-inner');
        }
        else if (this.config.toggle === 'popover') {
            tooltipTitleEl = tip.querySelector('.popover-header');
            tooltipContentEl = tip.querySelector('.popover-body');
        }
        if (tooltipTitleEl) {
            this.setElementContent(tooltipTitleEl, this.getTitle());
        }
        if (tooltipContentEl) {
            this.setElementContent(tooltipContentEl, this.getContent());
        }
        removeClass(tip, 'fade');
        removeClass(tip, 'show');
    };
    BsTooltip.prototype.setElementContent = function (el, content) {
        if (this.config.html) {
            if (content instanceof Element) {
                el.appendChild(content);
                return;
            }
            // eslint-disable-next-line no-param-reassign
            el.innerHTML = content;
        }
        else {
            if (content instanceof Element) {
                // eslint-disable-next-line no-param-reassign
                el.textContent = content.innerText;
                return;
            }
            // eslint-disable-next-line no-param-reassign
            el.textContent = content;
        }
    };
    BsTooltip.prototype.getContent = function () {
        if (this.config.content) {
            if (typeof this.config.content === 'function') {
                var newContent = this.config.content.call(this.tooltipEl);
                if (newContent instanceof Element) {
                    // detaches the content element
                    this.config.content = newContent;
                }
                return newContent;
            }
            return this.config.content;
        }
        return '';
    };
    BsTooltip.prototype.getTitle = function () {
        if (this.config.title) {
            if (typeof this.config.title === 'function') {
                var newTitle = this.config.title.call(this.tooltipEl);
                if (newTitle instanceof Element) {
                    // detaches the title element
                    this.config.content = newTitle;
                }
                return newTitle;
            }
            return this.config.title;
        }
        if (this.tooltipEl.dataset.originalTitle) {
            return this.tooltipEl.dataset.originalTitle;
        }
        return '';
    };
    BsTooltip.prototype.handleWatchBsTitle = function (newValue /* , oldValue */) {
        if (!this.isEnabled) {
            return;
        }
        if (this.config.title !== newValue) {
            this.config.title = newValue;
        }
        if (this.isWithActiveTrigger() || this.tipHasClass('show') || this.hoverState === 'show') {
            var tip = this.getTipElement();
            var innerContentEl = void 0;
            if (this.config.toggle === 'tooltip') {
                innerContentEl = tip.querySelector('.tooltip-inner');
            }
            else if (this.config.toggle === 'popover') {
                innerContentEl = tip.querySelector('.popover-header');
            }
            if (innerContentEl) {
                this.setElementContent(innerContentEl, this.getTitle());
                if (this.popperHandle && this.popperHandle.scheduleUpdate) {
                    this.popperHandle.scheduleUpdate();
                }
            }
        }
    };
    BsTooltip.prototype.handleWatchBsContent = function (newValue /* , oldValue */) {
        if (!this.isEnabled) {
            return;
        }
        if (this.config.toggle === 'tooltip') {
            return;
        }
        if (this.config.content !== newValue) {
            this.config.content = newValue;
        }
        if (this.isWithActiveTrigger() || this.tipHasClass('show') || this.hoverState === 'show') {
            var tip = this.getTipElement();
            var innerContentEl = tip.querySelector('.popover-body');
            if (innerContentEl) {
                this.setElementContent(innerContentEl, this.getContent());
                if (this.popperHandle && this.popperHandle.scheduleUpdate) {
                    this.popperHandle.scheduleUpdate();
                }
            }
        }
    };
    BsTooltip.prototype.bsRemoveEventListener = function (eventName, listenerFunction, callback) {
        if (callback === void 0) { callback = function () { }; }
        if (this.config.selector) {
            var elements = Array.prototype.slice.call(document.querySelectorAll(this.config.selector));
            if (elements && _size(elements) > 0) {
                for (var j = 0; j < elements.length; j += 1) {
                    elements[j].removeEventListener(eventName, listenerFunction);
                }
            }
        }
        this.tooltipEl.removeEventListener(eventName, listenerFunction);
        callback();
    };
    BsTooltip.prototype.bsAddEventListener = function (eventName, listenerFunction) {
        var _this = this;
        this.bsRemoveEventListener(eventName, listenerFunction, function () {
            if (_this.config.selector) {
                var elements = Array.prototype.slice.call(_this.tooltipEl.querySelectorAll(_this.config.selector));
                if (elements && _size(elements) > 0) {
                    for (var j = 0; j < elements.length; j += 1) {
                        elements[j].addEventListener(eventName, listenerFunction);
                    }
                    return;
                }
                console.error('unable to find elements matching selector falling back to using bs-tooltip');
            }
            _this.tooltipEl.addEventListener(eventName, listenerFunction);
        });
    };
    BsTooltip.prototype.setListeners = function () {
        var closestModal = closest(this.tooltipEl, '.modal');
        if (closestModal) {
            var modalHideEventName = closestModal.hideEventName;
            if (modalHideEventName) {
                closestModal.removeEventListener(closestModal.hideEventName, this.handleModalHide);
                closestModal.addEventListener(closestModal.hideEventName, this.handleModalHide);
            }
        }
        this.fixTitle();
        var triggers = split(toLower(this.config.trigger), ' ');
        if (includes_1(triggers, 'click')) {
            this.bsAddEventListener('click', this.handleClickTrigger);
        }
        if (includes_1(triggers, 'manual')) {
            // hover and focus events are ignored if manual is included.
            return;
        }
        if (includes_1(triggers, 'hover')) {
            this.bsAddEventListener('mouseenter', this.handleMouseEnter);
            this.bsAddEventListener('mouseleave', this.handleMouseLeave);
        }
        if (includes_1(triggers, 'focus')) {
            this.bsAddEventListener('focusin', this.handleFocusIn);
            this.bsAddEventListener('focusout', this.handleFocusOut);
        }
    };
    BsTooltip.prototype.fixTitle = function () {
        if (_size(this.tooltipEl.title) > 0) {
            this.tooltipEl.dataset.originalTitle = this.tooltipEl.title || '';
            this.tooltipEl.title = '';
        }
    };
    BsTooltip.prototype.setConfig = function (overrideConfig) {
        if (overrideConfig === void 0) { overrideConfig = {}; }
        this.config = {};
        var config = {};
        if (_has(this.tooltipEl.dataset, 'toggle')) {
            config.toggle = this.tooltipEl.dataset.toggle;
        }
        else {
            config.toggle = this.defaults.toggle;
        }
        if (_has(overrideConfig, 'animation')) {
            config.animation = getConfigBoolean(overrideConfig.animation);
        }
        else if (_has(this.tooltipEl.dataset, 'animation')) {
            config.animation = getConfigBoolean(this.tooltipEl.dataset.animation);
        }
        else {
            config.animation = this.defaults.animation;
        }
        if (_has(overrideConfig, 'trigger')) {
            config.trigger = overrideConfig.trigger;
        }
        else if (_has(this.tooltipEl.dataset, 'trigger')) {
            config.trigger = this.tooltipEl.dataset.trigger;
        }
        else if (config.toggle === 'popover') {
            config.trigger = this.defaults.popoverTrigger;
        }
        else {
            config.trigger = this.defaults.trigger;
        }
        var titleAttribute = this.tooltipEl.getAttribute('title');
        if (_size(this.bsTitle) > 0) {
            config.title = this.bsTitle;
        }
        else if (titleAttribute) {
            config.title = titleAttribute;
        }
        else if (_has(overrideConfig, 'title')) {
            if (typeof overrideConfig.title === 'object' && overrideConfig.title.nodeValue) {
                config.title = overrideConfig.title.nodeValue;
            }
            else {
                config.title = overrideConfig.title;
            }
        }
        else if (_has(this.tooltipEl.dataset, 'title')) {
            config.title = this.tooltipEl.dataset.title;
        }
        else {
            config.title = this.defaults.title;
        }
        if (_isNumber(config.title)) {
            config.title = toString(config.title);
        }
        if (_size(this.bsContent) > 0) {
            config.content = this.bsContent;
        }
        else if (_has(this.tooltipEl.dataset, 'content')) {
            config.content = this.tooltipEl.dataset.content;
        }
        else if (_has(overrideConfig, 'content')) {
            if (typeof overrideConfig.content === 'object' && overrideConfig.content.nodeValue) {
                config.content = overrideConfig.content.nodeValue;
            }
            else {
                config.content = overrideConfig.content;
            }
        }
        else {
            config.content = this.defaults.content;
        }
        if (_isNumber(config.content)) {
            config.content = toString(config.content);
        }
        var newConfigDelay;
        if (_has(overrideConfig, 'delay')) {
            newConfigDelay = overrideConfig.delay;
        }
        else if (_has(this.tooltipEl.dataset, 'delay')) {
            newConfigDelay = this.tooltipEl.dataset.delay;
        }
        if (isInteger_1(newConfigDelay)) {
            config.delay = {
                show: newConfigDelay,
                hide: newConfigDelay,
            };
        }
        else if (_isObject(newConfigDelay)) {
            config.delay = {
                show: _get(newConfigDelay, 'show', this.defaults.delay),
                hide: _get(newConfigDelay, 'hide', this.defaults.delay),
            };
        }
        else if (_isString(newConfigDelay) && _size(newConfigDelay) > 0) {
            var configDelayInteger = toInteger_1(newConfigDelay);
            if (!isNaN$1(configDelayInteger)) {
                config.delay = {
                    show: configDelayInteger,
                    hide: configDelayInteger,
                };
            }
            else {
                var configDelayObj = parseJson(newConfigDelay);
                config.delay = {
                    show: _get(configDelayObj, 'show', this.defaults.delay),
                    hide: _get(configDelayObj, 'hide', this.defaults.delay),
                };
            }
        }
        else {
            config.delay = {
                show: this.defaults.delay,
                hide: this.defaults.delay,
            };
        }
        if (_has(overrideConfig, 'html')) {
            config.html = getConfigBoolean(overrideConfig.html);
        }
        else if (_has(this.tooltipEl.dataset, 'html')) {
            config.html = getConfigBoolean(this.tooltipEl.dataset.html);
        }
        else {
            config.html = this.defaults.html;
        }
        if (_has(overrideConfig, 'selector')) {
            config.selector = overrideConfig.selector;
        }
        else if (_has(this.tooltipEl.dataset, 'selector')) {
            config.selector = this.tooltipEl.dataset.selector;
        }
        else {
            config.selector = this.defaults.selector;
        }
        if (_has(overrideConfig, 'placement')) {
            config.placement = overrideConfig.placement;
        }
        else if (_has(this.tooltipEl.dataset, 'placement')) {
            config.placement = this.tooltipEl.dataset.placement;
        }
        else if (config.toggle === 'popover') {
            config.placement = this.defaults.popoverPlacement;
        }
        else {
            config.placement = this.defaults.placement;
        }
        if (_has(overrideConfig, 'offset')) {
            config.offset = toInteger_1(overrideConfig.offset);
        }
        else if (_has(this.tooltipEl.dataset, 'offset')) {
            config.offset = toInteger_1(this.tooltipEl.dataset.offset);
        }
        else {
            config.offset = this.defaults.offset;
        }
        if (isNaN$1(config.offset)) {
            config.offset = this.defaults.offset;
        }
        if (_has(overrideConfig, 'container')) {
            config.container = getConfigBoolean(overrideConfig.container);
        }
        else if (_has(this.tooltipEl.dataset, 'container')) {
            config.container = getConfigBoolean(this.tooltipEl.dataset.container);
        }
        else {
            config.container = this.defaults.container;
        }
        if (_has(overrideConfig, 'fallbackPlacement')) {
            config.fallbackPlacement = overrideConfig.fallbackPlacement;
        }
        else if (_has(this.tooltipEl.dataset, 'fallbackPlacement')) {
            config.fallbackPlacement = this.tooltipEl.dataset.fallbackPlacement;
        }
        else {
            config.fallbackPlacement = this.defaults.fallbackPlacement;
        }
        if (_has(overrideConfig, 'boundary')) {
            config.boundary = overrideConfig.boundary;
        }
        else if (_has(this.tooltipEl.dataset, 'boundary')) {
            config.boundary = this.tooltipEl.dataset.boundary;
        }
        else {
            config.boundary = this.defaults.boundary;
        }
        if (_has(overrideConfig, 'disposeTimeToWait')) {
            config.disposeTimeToWait = toInteger_1(overrideConfig.disposeTimeToWait);
        }
        else if (_has(this.tooltipEl.dataset, 'disposeTimeToWait')) {
            config.disposeTimeToWait = toInteger_1(this.tooltipEl.dataset.disposeTimeToWait);
        }
        else {
            config.disposeTimeToWait = this.defaults.disposeTimeToWait;
        }
        if (isNaN$1(config.disposeTimeToWait)) {
            config.disposeTimeToWait = this.defaults.disposeTimeToWait;
        }
        if (_has(overrideConfig, 'template')) {
            config.template = overrideConfig.template;
        }
        else if (_has(this.tooltipEl.dataset, 'template')) {
            config.template = this.tooltipEl.dataset.template;
        }
        else if (config.toggle === 'popover') {
            config.template = this.defaults.popoverTemplate;
        }
        else {
            config.template = this.defaults.template;
        }
        this.config = config;
        // console.log('this.config: ', this.config);
        if (this.config.toggle === 'popover') {
            if (!this.tooltipEl.hasAttribute('show-event-name')) {
                this.showEventName = 'show.bs.popover';
            }
            if (!this.tooltipEl.hasAttribute('shown-event-name')) {
                this.shownEventName = 'shown.bs.popover';
            }
            if (!this.tooltipEl.hasAttribute('hide-event-name')) {
                this.hideEventName = 'hide.bs.popover';
            }
            if (!this.tooltipEl.hasAttribute('hidden-event-name')) {
                this.hiddenEventName = 'hidden.bs.popover';
            }
            if (!this.tooltipEl.hasAttribute('inserted-event-name')) {
                this.insertedEventName = 'inserted.bs.popover';
            }
            if (!this.tooltipEl.hasAttribute('enable-event-name')) {
                this.enableEventName = 'enable.bs.popover';
            }
            if (!this.tooltipEl.hasAttribute('enabled-event-name')) {
                this.enabledEventName = 'enabled.bs.popover';
            }
            if (!this.tooltipEl.hasAttribute('disable-event-name')) {
                this.disableEventName = 'disable.bs.popover';
            }
            if (!this.tooltipEl.hasAttribute('disabled-event-name')) {
                this.disabledEventName = 'disabled.bs.popover';
            }
        }
    };
    BsTooltip.prototype.handleDisabledWatch = function (newValue /* , oldValue */) {
        if (this.disabled === newValue && !this.isEnabled === newValue) {
            return;
        }
        if (newValue === true) {
            this.disableTooltip();
            return;
        }
        this.enableTooltip();
    };
    BsTooltip.prototype.handleShowPopoverWatch = function (newValue /* , oldValue */) {
        if (this.tooltipEl.dataset.toggle !== 'popover') {
            throw new Error('A popover must have [data-toggle="popover"]');
        }
        if (!this.isEnabled) {
            return;
        }
        if (newValue) {
            if (includes_1(this.config.trigger, 'click')) {
                this.activeTrigger.click = true;
            }
            else if (includes_1(this.config.trigger, 'hover') && !includes_1(this.config.trigger, 'manual')) {
                this.activeTrigger.hover = true;
                this.hoverState = 'show';
            }
            else if (includes_1(this.config.trigger, 'focus') && !includes_1(this.config.trigger, 'manual')) {
                this.activeTrigger.focus = true;
            }
            this.show();
            return;
        }
        this.hide();
    };
    BsTooltip.prototype.handleShowTooltipWatch = function (newValue /* , oldValue */) {
        if (this.tooltipEl.dataset.toggle !== 'tooltip') {
            throw new Error('A tooltip must have [data-toggle="tooltip"]');
        }
        if (!this.isEnabled) {
            return;
        }
        if (newValue === true) {
            this.enter();
            return;
        }
        this.leave();
    };
    BsTooltip.prototype.setupMethod = function (tooltipOptions) {
        if (_size(tooltipOptions) === 0) {
            if (!this.isEnabled) {
                this.enableTooltip();
                return true;
            }
            return this.tooltipEl;
        }
        if (tooltipOptions === 'enable') {
            this.enableTooltip();
            return true;
        }
        if (tooltipOptions === 'disable') {
            this.disableTooltip();
            return true;
        }
        // if (tooltipOptions === 'dispose') {
        //   this.disableTooltip();
        //   this.config = {};
        //   return true;
        // }
        if (tooltipOptions === 'toggleEnabled') {
            if (this.isEnabled) {
                this.disableTooltip();
            }
            else {
                this.enableTooltip();
            }
            return true;
        }
        if (tooltipOptions === 'show') {
            console.log('show');
            console.log('this.isEnabled: ', this.isEnabled);
            if (!this.isEnabled) {
                return null;
            }
            this.enter();
            return true;
        }
        if (tooltipOptions === 'hide') {
            this.activeTrigger = {};
            if (!this.isEnabled) {
                return null;
            }
            this.leave();
            return true;
        }
        if (tooltipOptions === 'toggle') {
            if (!this.isEnabled) {
                return null;
            }
            this.toggle();
            return true;
        }
        if (tooltipOptions === 'update') {
            if (this.popperHandle && this.popperHandle.scheduleUpdate) {
                this.popperHandle.scheduleUpdate();
                return true;
            }
            return false;
        }
        if (typeof tooltipOptions === 'object') {
            if (this.isEnabled) {
                this.disableTooltip();
            }
            this.setConfig(tooltipOptions);
            this.enableTooltip();
            return true;
        }
        if (typeof tooltipOptions === 'string') {
            throw new Error("No method named \"" + tooltipOptions + "\"");
        }
        return null;
    };
    BsTooltip.prototype.popover = function (popoverOptions) {
        if (popoverOptions === void 0) { popoverOptions = {}; }
        if (this.tooltipEl.dataset.toggle !== 'popover') {
            throw new Error('a popover requires [data-toggle="popover"]');
        }
        return this.setupMethod(popoverOptions);
    };
    BsTooltip.prototype.tooltip = function (tooltipOptions) {
        if (tooltipOptions === void 0) { tooltipOptions = {}; }
        if (this.tooltipEl.dataset.toggle === 'popover') {
            throw new Error('For a popover you must call the popover method not the tooltip method');
        }
        return this.setupMethod(tooltipOptions);
    };
    BsTooltip.prototype.render = function () {
        return (h("slot", null));
    };
    Object.defineProperty(BsTooltip, "is", {
        get: function () { return "bs-tooltip"; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BsTooltip, "properties", {
        get: function () {
            return {
                "activeTrigger": {
                    "state": true
                },
                "bsContent": {
                    "type": String,
                    "attr": "bs-content",
                    "mutable": true,
                    "watchCallbacks": ["handleWatchBsContent"]
                },
                "bsTitle": {
                    "type": String,
                    "attr": "bs-title",
                    "mutable": true,
                    "watchCallbacks": ["handleWatchBsTitle"]
                },
                "config": {
                    "type": "Any",
                    "attr": "config",
                    "mutable": true
                },
                "defaults": {
                    "type": "Any",
                    "attr": "defaults"
                },
                "disabled": {
                    "type": Boolean,
                    "attr": "disabled",
                    "mutable": true,
                    "watchCallbacks": ["handleDisabledWatch"]
                },
                "disabledEventName": {
                    "type": String,
                    "attr": "disabled-event-name",
                    "mutable": true
                },
                "disableEventName": {
                    "type": String,
                    "attr": "disable-event-name",
                    "mutable": true
                },
                "disposeTimeout": {
                    "state": true
                },
                "enabledEventName": {
                    "type": String,
                    "attr": "enabled-event-name",
                    "mutable": true
                },
                "enableEventName": {
                    "type": String,
                    "attr": "enable-event-name",
                    "mutable": true
                },
                "hiddenEventName": {
                    "type": String,
                    "attr": "hidden-event-name",
                    "mutable": true
                },
                "hideEventName": {
                    "type": String,
                    "attr": "hide-event-name",
                    "mutable": true
                },
                "hoverState": {
                    "state": true
                },
                "insertedEventName": {
                    "type": String,
                    "attr": "inserted-event-name",
                    "mutable": true
                },
                "isEnabled": {
                    "state": true
                },
                "popover": {
                    "method": true
                },
                "popperHandle": {
                    "state": true
                },
                "showEventName": {
                    "type": String,
                    "attr": "show-event-name",
                    "mutable": true
                },
                "shownEventName": {
                    "type": String,
                    "attr": "shown-event-name",
                    "mutable": true
                },
                "showPopover": {
                    "type": Boolean,
                    "attr": "show-popover",
                    "mutable": true,
                    "watchCallbacks": ["handleShowPopoverWatch"]
                },
                "showTooltip": {
                    "type": Boolean,
                    "attr": "show-tooltip",
                    "mutable": true,
                    "watchCallbacks": ["handleShowTooltipWatch"]
                },
                "tabindex": {
                    "type": "Any",
                    "attr": "tabindex",
                    "reflectToAttr": true,
                    "mutable": true
                },
                "timeout": {
                    "state": true
                },
                "tip": {
                    "state": true
                },
                "tooltip": {
                    "method": true
                },
                "tooltipEl": {
                    "elementRef": true
                },
                "tooltipId": {
                    "state": true
                }
            };
        },
        enumerable: true,
        configurable: true
    });
    return BsTooltip;
}());
export { BsTooltip };
