// https://developer.mozilla.org/en-US/docs/Web/API/Element/matches
// https://caniuse.com/#feat=matchesselector
// supports IE9+
function elementMatches(el, selector) {
    if (Element.prototype.msMatchesSelector) {
        return el.msMatchesSelector(selector);
    }
    return el.matches(selector);
}
// https://developer.mozilla.org/en-US/docs/Web/API/Element/closest
function closest(element, selectors) {
    if (Element.prototype.closest) {
        return element.closest(selectors);
    }
    var currentEl = element;
    if (!document.documentElement.contains(currentEl)) {
        return null;
    }
    do {
        if (elementMatches(currentEl, selectors)) {
            return currentEl;
        }
        currentEl = currentEl.parentElement || currentEl.parentNode;
    } while (currentEl !== null && currentEl.nodeType === 1);
    return null;
}
export { closest as a, elementMatches as b };
