import { i as toString, A as toString$1 } from './chunk-89dac778.js';
/** Used to generate unique IDs. */
var idCounter = 0;
/**
 * Generates a unique ID. If `prefix` is given, the ID is appended to it.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Util
 * @param {string} [prefix=''] The value to prefix the ID with.
 * @returns {string} Returns the unique ID.
 * @example
 *
 * _.uniqueId('contact_');
 * // => 'contact_104'
 *
 * _.uniqueId();
 * // => '105'
 */
function uniqueId(prefix) {
    var id = ++idCounter;
    return toString(prefix) + id;
}
var uniqueId_1 = uniqueId;
function getUniqueId(prefix) {
    var randomString = btoa(toString$1(Math.random())).substring(5, 10);
    return uniqueId_1(prefix + "-" + randomString + "-");
}
export { getUniqueId as a };
